package com.huimv.production.service.impl;

import com.huimv.production.domain.IndexParameterEntity;
import com.huimv.production.repo.IndexParameterEntityRepository;
import com.huimv.production.result.Result;
import com.huimv.production.result.ResultStatus;
import com.huimv.production.service.IndexParameterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/5 0005 10:56
 **/
@Service
public class IndexParameterServiceImpl implements IndexParameterService {
    @Autowired
    private IndexParameterEntityRepository parameterEntityRepository;

    @Override
    public Result add(IndexParameterEntity parameterEntity) {
        if (parameterEntity == null){
           return new Result(10002,"请输入参数");
        }
        try {
            parameterEntity.setCheckParameter(false);
            parameterEntityRepository.save(parameterEntity);
            return new Result(10000,"添加成功");
        }catch (Exception e){
            return new Result(10001,"添加失败");
        }


    }

    @Override
    public Result remove(Integer[] ids) {
        if (ids == null || ids.length==0){
            return new Result(10002,"请选择要删除的数据");
        }
        try {
            for (Integer id : ids) {
                parameterEntityRepository.deleteById(id);
            }

            return new Result(10000,"删除成功");
        }catch (Exception e){
            return new Result(10001,"删除失败");
        }
    }
    //暂时有疑问
    @Override
    public Result update(IndexParameterEntity parameterEntity) {
        if (parameterEntity == null){
            return new Result(10002,"请选择要修改的值");
        }
        try {
            parameterEntity.setCreateTime(parameterEntityRepository.findById(parameterEntity.getId()).get().getCreateTime());
            parameterEntity.setUpdateTime(new Date());
            parameterEntityRepository.save(parameterEntity);
            return new Result(10000,"修改成功");
        }catch (Exception e){
            return new Result(10001,"修改失败");
        }

    }

    @Override
    public Result findAll() {
        try {
            return new Result(10000, ResultStatus.findSuccess,parameterEntityRepository.findAll());
        }catch (Exception e){
            return new Result(10001, ResultStatus.findFailed,null);
        }
    }




  /*  @Override
    public Result findAll() {
        try {
            List<IndexParameterEntity> all = parameterEntityRepository.findAll();
            return new Result(10000,"查询成功",all);
        }catch (Exception e){
            return new Result(10001,"查询失败",null);
        }

    }*/
}
