package com.huimv.production.service.impl;

import com.huimv.production.domain.MLaborRoomHeatEntity;
import com.huimv.production.domain.MSowChildbirthRecordEntity;
import com.huimv.production.domain.MSowEntity;
import com.huimv.production.repo.*;
import com.huimv.production.result.Result;
import com.huimv.production.result.ResultStatus;
import com.huimv.production.service.MSowChildbirthRecordService;
import com.huimv.production.service.MSowService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/9 0009 17:43
 **/
@Service
public class MSowChildbitrhRecordServiceImpl implements MSowChildbirthRecordService {
    @Autowired
    private MSowChildbirthRecordEntityRepo childcareEntityRepo;



    @Override
    public Result add(MSowChildbirthRecordEntity childcareEntity) {
        if (childcareEntity == null){
            return new Result(10002,"请输入参数");
        }
        try {
            childcareEntityRepo.save(childcareEntity);
            return new Result(10000,"添加成功");
        }catch (Exception e){
            return new Result(10001,"添加失败");
        }
    }

    @Override
    public Result remove(Integer[] ids) {
        if (ids == null || ids.length==0){
            return new Result(10002,"请选择要删除的数据");
        }
        try {
            for (Integer id : ids) {
                childcareEntityRepo.deleteById(id);
            }

            return new Result(10000,"删除成功");
        }catch (Exception e){
            return new Result(10001,"删除失败");
        }
    }

    @Override
    public Result update(MSowChildbirthRecordEntity childcareEntity) {
        if (childcareEntity == null){
            return new Result(10002,"请选择要修改的值");
        }
        try {
            childcareEntityRepo.save(childcareEntity);
            return new Result(10000,"修改成功");
        }catch (Exception e){
            return new Result(10001,"修改失败");
        }
    }

    @Override
    public Result findAll(String name ,Integer pageNum , Integer pageSize) {
        try {
            Map map = new HashMap();
            int size = childcareEntityRepo.findAll().size() ;
            Integer startPage = (pageNum-1) * pageSize;
            List<MSowChildbirthRecordEntity> all = childcareEntityRepo.findAll(name,startPage,pageSize);
            map.put("total",size);
            map.put("totalPageNum",(size  +  pageSize  - 1) / pageSize);
            map.put("data",all);

            return new Result(10000, ResultStatus.findSuccess,map);
        }catch (Exception e){
            return new Result(10001,ResultStatus.findFailed,null);
        }
    }

    @Override
    public Result findAllByLaborRoomState(Integer laborRoomState) {

        List<MSowChildbirthRecordEntity> allByLaborRoomState = childcareEntityRepo.findAllByLaborRoomState(laborRoomState);

        List list  = new ArrayList();
        switch (laborRoomState){
            case 0:
                for (MSowChildbirthRecordEntity record : allByLaborRoomState) {
                    Map map = new HashMap();
                    map.put("roomNo",record.getRoomCode());
                    map.put("roomState","空闲");
                    map.put("id",record.getId());
                    list.add(map);
                }
                break;
            case 1:
                for (MSowChildbirthRecordEntity record : allByLaborRoomState) {
                    Map map = new HashMap();
                    map.put("roomNo",record.getRoomCode());
                    map.put("sowCode",record.getSowCode());
                    map.put("roomState","待产");
                    map.put("conceptionDate",record.getConceptionDate());
                    map.put("intoRoomDate",record.getIntoRoomDate());
                    map.put("id",record.getId());
                    list.add(map);
                }
                break;
            case 2:
                for (MSowChildbirthRecordEntity record : allByLaborRoomState) {
                    Map map = new HashMap();
                    map.put("roomNo",record.getRoomCode());
                    map.put("sowCode",record.getSowCode());
                    map.put("birthState",record.getBirthState());
                    map.put("conceptionDate",record.getConceptionDate());
                    map.put("intoRoomDate",record.getIntoRoomDate());
                    map.put("id",record.getId());
//                    map.put("")
                    list.add(map);
                }
                break;
            case 3:
                for (MSowChildbirthRecordEntity record : allByLaborRoomState) {
                    Map map = new HashMap();
                    map.put("roomNo",record.getRoomCode());
                    map.put("sowCode",record.getSowCode());
                    map.put("roomState","哺乳");
                    map.put("conceptionDate",record.getConceptionDate());
                    map.put("intoRoomDate",record.getIntoRoomDate());
                    map.put("finishDate",record.getFinishDate());
                    map.put("id",record.getId());
                    list.add(map);
                }
                break;
            default:
                for (MSowChildbirthRecordEntity record : allByLaborRoomState) {
                    Map map = new HashMap();
                    map.put("roomNo",record.getRoomCode());
                    map.put("sowCode",record.getSowCode());
                    map.put("roomState","断奶");
                    map.put("days",record.getDays());
                    map.put("quantity",record.getQuantity());
                    map.put("incubatorHeat",record.getIncubatorHeat());
                    map.put("id",record.getId());
                    list.add(map);
                }
                break;

        }

        return new Result(10000,"成功",list);
    }

    @Autowired
    private MLaborRoomHeatEntityRepo roomRepo;
    @Autowired
    private MSowAnimalHeatEntityRepo sowRepo;
    @Autowired
    private MIncubatorHeatEntityRepo boxRepo;
    @Autowired
    private MChildbirthProgressEntityRepo progressEntityRepo;
    @Autowired
    private MFeedDetailEntityRepo detailEntityRepo;
    @Autowired
    private MPigletHealthCountEntityRepo countEntityRepo;
    @Autowired
    private MSowEntityRepo sowEntityRepo;
    @Autowired
    private MSowCopulationEntityRepo sowCopulationEntityRepo;
    @Autowired
    private  MSowPregnancyTestEntityRepo testEntityRepo;

    @Override
    public Result findById(Integer id) {

        MSowChildbirthRecordEntity record = childcareEntityRepo.findById(id).get();
        Map endMap = new HashMap();

        endMap.put("sowNo",record.getSowCode());
        endMap.put("age",record.getAge());
        endMap.put("birthNo",record.getBirthNo());
        endMap.put("quantity",record.getQuantity());
        endMap.put("roomCode",record.getRoomCode());
        //母猪信息
        endMap.put("sow",sowEntityRepo.findBySowCode(record.getSowCode()));
        //配种信息
        endMap.put("sowCopulationEntityRepo",sowCopulationEntityRepo.findAllBySowCode(record.getSowCode()));
        //娠检信息
        endMap.put("pregnancy",testEntityRepo.findAllBySowCode(record.getSowCode()));
        //产仔分布图
        endMap.put("littlePig",countEntityRepo.findAllBySowCode(record.getSowCode()));


        endMap.put("day",record.getDays());
        endMap.put("total",record.getTotal());
        endMap.put("boyPig",record.getBoarPigletTotal());
        endMap.put("girlPig",record.getSowPigletTotal());
        switch (record.getLaborRoomState()){
            case 1:
                //产房温度
                List<MLaborRoomHeatEntity> allByRoomCode = roomRepo.findAllByRoomCode(record.getRoomCode());
                endMap.put("roomHeat",allByRoomCode);
               /* List list = new ArrayList();
                for (MLaborRoomHeatEntity roomHeat : allByRoomCode) {
                    Map map = new HashMap();
                    map.put("time",roomHeat.getDate());
                    map.put("heat",roomHeat.getDate());
                    list.add(map);
                }
                endMap.put("roomHeat",list);*/
                //母猪温度
                List allByLocationId = sowRepo.findAllByLocationId(record.getSowCode());
                endMap.put("sowHeat",allByLocationId);
                break;
            case 2:

                endMap.put("birthState",record.getBirthState());
                //产房温度
                endMap.put("roomHeat",roomRepo.findAllByRoomCode(record.getRoomCode()));
                //母猪温度
                endMap.put("sowHeat",sowRepo.findAllByLocationId(record.getSowCode()));
                //保温箱温度
                endMap.put("boxHeat",boxRepo.findAllByRoomCode(record.getRoomCode()));
                //产仔进度图
                endMap.put("progress",progressEntityRepo.findAllByRoomCode(record.getRoomCode()));

                break;
            case 3:
                endMap.put("startTime",record.getFirstDate());
                endMap.put("endTime",record.getFinishDate());
                endMap.put("total",record.getTotal());
                endMap.put("weight",record.getAverageWeight());
                //产房温度
                endMap.put("roomHeat",roomRepo.findAllByRoomCode(record.getRoomCode()));
                //母猪温度sowAnimalHeat
                endMap.put("sowHeat",sowRepo.findAllByLocationId(record.getSowCode()));
                //保温箱温度
                endMap.put("boxHeat",boxRepo.findAllByRoomCode(record.getRoomCode()));
                //智能饲喂
                endMap.put("eat",detailEntityRepo.findAllByRoomCode(record.getRoomCode()));
//                //猪仔分布图
//                endMap.put("littlePig",countEntityRepo.findAllByRoomCode(record.getRoomCode()));

                break;
            default:
                endMap.put("startTime",record.getFirstDate());
                endMap.put("endTime",record.getFinishDate());
                endMap.put("total",record.getTotal());
                endMap.put("weight",record.getAverageWeight());
                endMap.put("successOdds",record.getRadio());
                endMap.put("failedOdds",100-record.getRadio());
                //保温箱温度
                endMap.put("boxHeat",boxRepo.findAllByRoomCode(record.getRoomCode()));
//                //猪仔分布图
//                endMap.put("littlePig",countEntityRepo.findAllByRoomCode(record.getRoomCode()));
                break;
        }
        return new Result(10000,"成功",endMap);
    }

}
