package com.huimv.security.controller;

import cn.hutool.json.JSONObject;
import com.huimv.security.domain.FaceUserEntity;
import com.huimv.security.domain.FaceUserImgEntity;
import com.huimv.security.result.Result;
import com.huimv.security.service.FaceRecoService;
import com.huimv.security.service.FaceSbdaService;
import com.huimv.security.service.FaceUserImgService;
import com.huimv.security.service.FaceUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.Base64;
import java.util.List;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.security.controller
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/7 0007 15:46
 **/
@RestController
@RequestMapping("/face")

public class FaceController {

    @Autowired
    FaceUserService userService;

    @Autowired
    FaceSbdaService sbdaService;

    @Autowired
    FaceRecoService recoService;

    @Autowired
    FaceUserImgService userImgService;

    /*
    * @Method      : intoOutCount
    * @Description : 查询进出总量
    * @Params      : []
    * @Return      : com.huimv.security.result.Result
    *
    * @Author      : yuxuexuan
    * @Date        : 2021/3/7 0007
    * @Time        : 16:14
    */
    @RequestMapping("/intoOutCount")
    private Result intoOutCount(){
        List list = recoService.intoOutCount();

        return new Result(10000,"成功",list);
    }


    @RequestMapping("/oneDay")
    private Result oneDay(){
        List list = recoService.oneDay();

        return new Result(10000,"成功",list);
    }


    @RequestMapping("/oneWeek")
    private Result oneWeek(){
        List list = recoService.oneWeek();

        return new Result(10000,"成功",list);
    }

    @RequestMapping("/oneMouth")
    private Result oneMouth(){
        List list = recoService.oneMouth();

        return new Result(10000,"成功",list);
    }

    @PostMapping("/upload")
    public  Result upload(String XM , String USERID, @RequestParam(required = true) MultipartFile file){
        return userImgService.upload(XM,USERID,file);
    }

    @RequestMapping("/findImg")
    public Result findImg (){
//        List<FaceUserEntity> userList = userService.findAll();
//        FaceUserEntity faceUserEntity = userList.get(0);
//        faceUserEntity.getUSERID();
//        faceUserEntity.getXM();

        List<FaceUserImgEntity> list = userImgService.findImg();
        byte[] img = list.get(0).getImg();
        String imgBase64 = "data:image/jpg;base64,"+ Base64.getEncoder().encodeToString(img);
        return new Result(10000,"查询成功",imgBase64);
    }
}
