package com.huimv.security.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "face_sbda")
@Data
public class FaceSbdaEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "ID", nullable = false)
    private Integer ID;

    @Column(name = "MCID")
    private Integer MCID;

    /**
     * 设备ID
     */
    @Column(name = "SBID")
    private String SBID;

    /**
     * 名称
     */
    @Column(name = "SBMC")
    private String SBMC;

    /**
     * 备注
     */
    @Column(name = "BZ")
    private String BZ;

    /**
     * 修改时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss" ,timezone = "GMT+8")
    @LastModifiedDate
    @Column(name = "XGSJ")
    private Date XGSJ;

    /**
     * 作废标志
     */
    @Column(name = "ZFBZ")
    private Integer ZFBZ;

}
